c AutoDipole - Packege of an automated dipole subtraction by 
c Kouhei Hasegawa, Sven Moch, and Peter Uwer, Nucl.Phys.Proc.Suppl.183:268-273,2008
      
      subroutine maptocollinear_ff(collmass,collmom,p1,p2,thetacoll,
     & rootsij)
      implicit none
      
      REAL*8 p1(0:3),p2(0:3)
      REAL*8 collmass,collmom(0:3),delta,absmomem,costheta,sintheta
      REAL*8 absmomenxy,cosphi,sinphi,tot(0:3),thetacoll,rootsij,DOT
      
      delta=collmass*collmom(0)**(-1)
      thetacoll=DACOS(1.d0-2.d0*delta**2) 
      absmomem=dsqrt(collmom(0)**2 - collmass**2) 
      costheta=collmom(3)*absmomem**(-1)
      sintheta=dsqrt(1.d0 - costheta**2) 
      absmomenxy=dsqrt(collmom(1)**2 + collmom(2)**2) 
      cosphi=collmom(1)*absmomenxy**(-1)
      sinphi=collmom(2)*absmomenxy**(-1)
      
      p1(0)=collmom(0)/2.d0
      p1(1)=collmom(1)/2.d0 + collmass*costheta*cosphi/2.d0
      p1(2)=collmom(2)/2.d0 + collmass*costheta*sinphi/2.d0
      p1(3)=collmom(3)/2.d0 - collmass*sintheta/2.d0
      
      p2(0)=collmom(0)/2.d0
      p2(1)=collmom(1)/2.d0 - collmass*costheta*cosphi/2.d0
      p2(2)=collmom(2)/2.d0 - collmass*costheta*sinphi/2.d0
      p2(3)=collmom(3)/2.d0 + collmass*sintheta/2.d0
      
      rootsij=dsqrt(dabs(2.d0*DOT(p1,p2)))
      
      return
      end

      subroutine maptocollinear_if(R,delta,costheta,sintheta,cphi,sphi,
     &          P,costhetaprime,sinthetaprime,thetacoll)
      
      REAL*8 costheta,sintheta,cphi,sphi
      REAL*8 costhetacoll,sinthetacoll
      REAL*8 costhetaprime,sinthetaprime
      REAL*8 delta,thetacoll
      REAL*8 P(0:3),R(0:3)
      
      costhetacoll=dsqrt(1.d0-delta**2)
      sinthetacoll=delta
      thetacoll=dasin(sinthetacoll)
      
      costhetaprime=costheta*costhetacoll + sintheta*sinthetacoll 
      sinthetaprime=sintheta*costhetacoll - costheta*sinthetacoll
     
c      print*,'I am theta,phi,thetacollif'
c      write(*,'(i2,1x,4e30.15)') l,theta,cphi,sphi,thetacollif
      
      call collinearmif(R,costheta,sintheta,costhetaprime,
     &   sinthetaprime,p) 
      
      return
      end
      
      subroutine getthetaphi(pcoll,costheta,sintheta,cphi,sphi)
      implicit none
      INTEGER i,j,k
      REAL*8 pcoll(0:3),costheta,sintheta,cphi,sphi,absmomenxy
      absmomenxy=dsqrt(pcoll(1)**2 + pcoll(2)**2) 
      costheta=pcoll(3)*pcoll(0)**(-1)
      sintheta=absmomenxy*pcoll(0)**(-1)
      cphi=pcoll(1)*absmomenxy**(-1)
      sphi=pcoll(2)*absmomenxy**(-1)
c      print*,'I am in getthetaphi theta,cphi,sphi,absmomenxy'
c      write(*,'(4e30.15)') theta,cphi,sphi,absmomenxy
      end

      subroutine collinearmif(pcoll,costheta,sintheta,costhetaprime,
     &   sinthetaprime,qcoll)
      implicit none
      REAL*8 costheta,sintheta,costhetaprime,sinthetaprime
      REAL*8 pcoll(0:3),qcoll(0:3)
      qcoll(0)=pcoll(0)
      qcoll(1)=pcoll(0)*(costhetaprime*sintheta-sinthetaprime*costheta)
      qcoll(2)=0.d0
      qcoll(3)=pcoll(0)*(sinthetaprime*sintheta+costhetaprime*costheta)
c      print*,'I am in collinearmif'
c      write(*,'(4e30.15)') qcoll(0),qcoll(1),qcoll(2),qcoll(3)
      end

      subroutine othmom(pother,cphi,sphi,costhetaprime,sinthetaprime,
     &  qother)
      implicit none
      REAL*8 cphi,sphi,costhetaprime,sinthetaprime
      REAL*8 pother(0:3),qother(0:3)
      qother(0)=pother(0)
      qother(1)=costhetaprime*cphi*pother(1)
     &     +costhetaprime*sphi*pother(2) - sinthetaprime*pother(3)
      qother(2)=-sphi*pother(1)+cphi*pother(2)
      qother(3)=sinthetaprime*cphi*pother(1)
     &     +sinthetaprime*sphi*pother(2) + costhetaprime*pother(3)
      
c      print*,'I am in otherm'
c      write(*,'(4e30.15)') qother(0),qother(1),qother(2),qother(3)
      
      end

      subroutine showmomenta(nexternald,Pd,thetacolld,horizond)
      implicit none
      
      integer nexternald,i
      REAL*8 Pd(0:3,NEXTERNALd),thetacolld,horizond,dot
      
      do i=1,nexternald
         write (*,'(i2,1x,5e25.16)') i, Pd(0,i),Pd(1,i),Pd(2,i),Pd(3,i), 
     .dsqrt(dabs(DOT(pd(0,i),pd(0,i))))
      enddo
      write (*,'(1e26.16)') thetacolld
      write (*,'(1e26.16)') horizond

      return
      end








